# QCircScape

## Summary:

This work applies concepts from algorithmic probability to Boolean and quantum combinatorial logic circuits. The relations among the statistical, algorithmic, computational and circuit complexities of states are reviewed. Thereafter, the probability of states in the circuit model of computation is defined. Classical and quantum gate sets are compared to select some characteristic sets. The reachability and expressibility in a space-time-bounded setting for these gate sets are enumerated and visualized. These results are studied in terms of computational resources, universality and quantum behavior. The article suggests how applications like geometric quantum machine learning, novel quantum algorithm synthesis and quantum artificial general intelligence can benefit by studying circuit probabilities.

## Collaborators:
* Bao Gia Bach - Faculty of Computer Science and Engineering, Ho Chi Minh City University of Technology, Viet Nam
* Akash Kundu - Joint Doctoral School, Silesian University of Technology, Gliwice, Poland and Institute of Theoretical and Applied Informatics, Polish Academy of Sciences, Gliwice, Poland
* Tamal Acharya - Independent Researcher, Bengaluru, India
* Aritra Sarkar - Quantum Machine Learning research group, QuTech, Department of Quantum and Computer Engineering, Delft University of Technology, The Netherlands

## Link to article:

[Visualizing Quantum Circuit Probability - estimating computational action for quantum program synthesis](https://arxiv.org/abs/2304.02358)
